<sqtm-core-entity-view-wrapper [sqtmCoreWorkspace]="'test-case-workspace'">
  <div class="flex-row full-height full-width overflow-hidden">
    <sqtm-core-nav-bar class="full-height flex-fixed-size"></sqtm-core-nav-bar>
    @if (componentData$ | async; as componentData) {
      <div
        class="flex-column full-width full-height neutral-background-color overflow-hidden"
      >
        <sqtm-core-configurable-banner />
        <div class="flex-fixed-size p-10">
          <div class="flex-row full-width">
            <span class="view-label m-l-10 font-16-px">{{
              'sqtm-core.detailed-test-step-view.label' | translate
            }}</span>
            <div class="m-l-auto m-r-10">
              @if (!componentData.milestonesAllowModification) {
                <span class="font-20-px sqtm-core-error-message m-r-40">
                  <i
                    nz-icon
                    nzType="sqtm-core-nav:milestone"
                    nzTheme="outline"
                    class="action-icon-size"
                    nz-tooltip
                    [nzTooltipTitle]="
                      'sqtm-core.entity.generic.milestone.locked' | translate
                    "
                    nzTooltipPlacement="bottom"
                  ></i>
                </span>
              }
            </div>
          </div>
          <div class="flex-row full-width">
            <sqtm-core-back-button
              class="m-t-6"
              [attr.data-test-element-id]="'return-to-previous-page-button'"
              (buttonPressed)="navigateBack()"
            >
            </sqtm-core-back-button>
            <div
              [attr.data-test-element-id]="'test-case-name'"
              class="sqtm-core-screen-title m-l-20"
            >
              {{ getTestCaseName(componentData) }}
            </div>
          </div>
        </div>
        @if (
          detailedTestStepViewService.currentStepData$ | async;
          as currentStepData
        ) {
          <div class="flex-row full-height overflow-hidden p-5">
            @if (currentStepData.kind !== 'call-step') {
              <div
                class="full-height full-width flex-column overflow-hidden p-5"
              >
                <div
                  class="flex-fixed-size full-width flex-row p-5 current-workspace-main-color section-header"
                >
                  <div class="m-l-5">
                    {{
                      'sqtm-core.test-case-workspace.title.coverages'
                        | translate
                    }}
                  </div>
                  <div
                    class="m-l-auto font-20-px"
                    [attr.data-test-element-id]="'coverages-actions'"
                  >
                    <sqtm-core-toggle-icon
                      [active]="
                        !(
                          detailedTestStepViewService.stepCreationMode$ | async
                        ) &&
                        componentData.milestonesAllowModification &&
                        componentData.permissions.canLink
                      "
                      (clickedInActiveMode)="openRequirementTreePicker()"
                    >
                      <i
                        [attr.data-test-element-id]="'add-coverages'"
                        nz-tooltip="{{
                          'sqtm-core.test-case-workspace.coverages.add'
                            | translate
                            | capitalize
                        }}"
                        nz-icon
                        class="m-r-15 action-icon-size"
                        nzType="sqtm-core-generic:add"
                        nzTheme="outline"
                      ></i>
                    </sqtm-core-toggle-icon>
                    <sqtm-core-toggle-icon
                      [active]="
                        !(
                          detailedTestStepViewService.stepCreationMode$ | async
                        ) &&
                        componentData.milestonesAllowModification &&
                        componentData.permissions.canLink
                      "
                      (clickedInActiveMode)="
                        navigateToSearchRequirementForStepCoverage(
                          componentData.testCase
                        )
                      "
                    >
                      <i
                        [attr.data-test-icon-id]="'search-coverages'"
                        nz-tooltip="{{
                          'sqtm-core.test-case-workspace.coverages.search'
                            | translate
                            | capitalize
                        }}"
                        nz-icon
                        class="m-r-15 action-icon-size remove-chrome-router-link-border"
                        nzType="sqtm-core-tree:search"
                        nzTheme="outline"
                      ></i>
                    </sqtm-core-toggle-icon>
                    <sqtm-core-toggle-icon
                      [active]="
                        !(
                          detailedTestStepViewService.stepCreationMode$ | async
                        ) && activateDeleteCoverageButton$ | async
                      "
                    >
                      <i
                        [attr.data-test-toolbar-button-id]="'remove-coverages'"
                        nz-tooltip="{{
                          'sqtm-core.test-case-workspace.coverages.delete'
                            | translate
                            | capitalize
                        }}"
                        nz-icon
                        class="m-r-15 action-icon-size"
                        nzType="sqtm-core-generic:unlink"
                        nzTheme="outline"
                        nz-dropdown
                        [nzDropdownMenu]="deleteCoverageMenu"
                        [nzDisabled]="!(activateDeleteCoverageButton$ | async)"
                      ></i>
                    </sqtm-core-toggle-icon>
                    <nz-dropdown-menu #deleteCoverageMenu="nzDropdownMenu">
                      <ul
                        [attr.data-test-menu-id]="'remove-coverages'"
                        nz-menu
                        nzSelectable
                      >
                        <li
                          nz-menu-item
                          [attr.data-test-menu-item-id]="
                            'delete-requirement-coverage-from-test-case'
                          "
                          (click)="showDeleteCoverageFromTestCase()"
                        >
                          {{
                            'sqtm-core.detailed-test-step-view.dialogs.coverages.remove-many.from-test-case.button'
                              | translate
                          }}
                        </li>
                        <li
                          nz-menu-item
                          [attr.data-test-menu-item-id]="
                            'delete-requirement-coverage-from-test-step'
                          "
                          [nzDisabled]="
                            !(activateDeleteCoverageFromStep$ | async)
                          "
                          (click)="showDeleteCoverageFromTestStep()"
                        >
                          {{
                            'sqtm-core.detailed-test-step-view.dialogs.coverages.remove-many.from-test-step.button'
                              | translate
                          }}
                        </li>
                      </ul>
                    </nz-dropdown-menu>
                  </div>
                </div>
                <div
                  [attr.data-test-element-id]="'requirement-drop-zone'"
                  #dropRequirementZone
                  class="full-width full-height overflow-hidden container-background-color container-border"
                  [sqtmCoreDraggableDropZone]="'requirement-table-drop-zone'"
                  (dragEnter)="dragEnter($event)"
                  (dragLeave)="dragLeave($event)"
                  (drop)="drop($event)"
                  (dragCancel)="removeBorderOnRequirementTable()"
                >
                  <div
                    class="full-width full-height p-10"
                    style="overflow: auto"
                  >
                    <sqtm-app-detailed-step-coverage-table></sqtm-app-detailed-step-coverage-table>
                  </div>
                </div>
              </div>
            }
            <div class="full-height full-width flex-column overflow-hidden p-5">
              <div
                class="flex-fixed-size full-width flex-row p-5 current-workspace-main-color test-step-header section-header"
              >
                <div class="m-l-5">
                  {{
                    'sqtm-core.detailed-test-step-view.steps.title' | translate
                  }}
                </div>
                <div>
                  <sqtm-core-step-navigator
                    [currentStep]="componentData.testCase.currentStepIndex"
                    [totalStep]="componentData.testCase.testSteps.ids.length"
                    [minimumStep]="0"
                    [disabled]="
                      detailedTestStepViewService.stepCreationMode$ | async
                    "
                    (navigateTo)="handleNavigateTo($event)"
                  >
                  </sqtm-core-step-navigator>
                </div>
                @if (!(detailedTestStepViewService.stepCreationMode$ | async)) {
                  <div class="font-20-px flex-row">
                    <sqtm-core-toggle-icon
                      [active]="
                        componentData.permissions.canWrite &&
                        componentData.milestonesAllowModification
                      "
                      (clickedInActiveMode)="showAddActionStepForm()"
                    >
                      <i
                        [attr.data-test-element-id]="
                          'show-create-action-step-form'
                        "
                        nz-tooltip="{{
                          'sqtm-core.test-case-workspace.test-steps.button.add-step'
                            | translate
                            | capitalize
                        }}"
                        nz-icon
                        class="m-r-15 __hover_pointer action-icon-size"
                        nzType="sqtm-core-generic:add"
                        nzTheme="outline"
                      ></i>
                    </sqtm-core-toggle-icon>
                    <sqtm-core-toggle-icon
                      [active]="
                        componentData.permissions.canWrite &&
                        componentData.milestonesAllowModification
                      "
                      (clickedInActiveMode)="showDeleteStepDialog()"
                    >
                      <i
                        [attr.data-test-element-id]="'remove-step'"
                        nz-tooltip="{{
                          'sqtm-core.test-case-workspace.test-steps.button.delete-step'
                            | translate
                            | capitalize
                        }}"
                        nz-icon
                        class="m-r-15 __hover_pointer action-icon-size"
                        nzType="sqtm-core-generic:delete"
                        nzTheme="outline"
                      ></i>
                    </sqtm-core-toggle-icon>
                  </div>
                } @else {
                  <div class="font-20-px flex-row">
                    <button
                      [attr.data-test-element-id]="'confirm-add-test-step'"
                      class="flex-fixed-size m-l-10"
                      nz-button
                      nzType="primary"
                      (click)="handleAddActionTestStep()"
                    >
                      {{ 'sqtm-core.generic.label.add' | translate }}
                    </button>
                    <button
                      [attr.data-test-element-id]="'cancel-add-test-step'"
                      class="flex-fixed-size m-l-10"
                      nz-button
                      nzType="default"
                      [disabled]="
                        (componentData$ | async).testCase.testSteps.ids
                          .length <= 1
                      "
                      (click)="handleCancelAddActionTestStep()"
                    >
                      {{ 'sqtm-core.generic.label.cancel' | translate }}
                    </button>
                  </div>
                }
              </div>
              <div
                #dropFileZone
                [attr.data-test-element-id]="'attachment-drop-zone'"
                class="full-width full-height overflow-hidden container-background-color container-border"
                sqtmCoreAttachmentDropZone
                (filesDropEvent)="dropFiles($event)"
                (filesDragEnterEvent)="dragFilesEnter()"
                (filesDragLeaveEvent)="dragFileLeave()"
              >
                <router-outlet></router-outlet>
              </div>
            </div>
          </div>
        } @else {
          <router-outlet></router-outlet>
        }
      </div>
      <sqtm-core-drawer
        [localTheme]="requirementWorkspace"
        [isVisible]="componentData.testCase.uiState.openRequirementTreePicker"
        [titleKey]="'sqtm-core.tree-picker.requirement.title'"
        (close)="closeRequirementPicker()"
      >
        @if (componentData.testCase.uiState.openRequirementTreePicker) {
          <sqtm-core-requirement-picker
            [pickerPersistenceKey]="'bind-requirement-to-test-case'"
          >
          </sqtm-core-requirement-picker>
        }
      </sqtm-core-drawer>
    }
  </div>
</sqtm-core-entity-view-wrapper>
